#include "puzzle.h"


static ull rec[60][150];
static ull *benutzt[12];
static int ecnt;

#ifdef DUMP
/* Gibt eine Lsung aus
 * unterste ebene von hinten nach vorne,
 * mittlere ebene        "
 * obere    ebene        "
 *
 * level: wieviele Teile sind bereits eingepasst (fr Teillsungen)
 */
static void edump(void)
{
	char erg[60+1];
	int i,j,k;
	sprintf(erg,"%60s","");
	for ( i = 0 ; i < 12 ; i++ )
		for ( j = 0 ; j < 60 ; j++ )
			if ( *benutzt[i] & (1LL<<j) )
				erg[j] = 'a'+i;
	for ( k = 0 ; k < 60 ; k += 20 )
	{
		for ( j = k ; j < k + 20 ; j += 5 )
		{
			for ( i = j ; i < j + 5 ; i++ )
				write(1,erg+i,1);
			write(1," ",1);
		}
		write(1," ",1);
	}
	write(1,"\n",1);
}
#endif

/* usserste rekurtionsstufe 
 *
 * highbit: Nummer des hchsten nicht gesetzten bits.
 * (hier eigentlich immer 59)
 */
//#define MMXAND(a,b) __builtin_ia32_pand(a,b)
//#define MMXOR(a,b) __builtin_ia32_por(a,b)
#define MMXAND(a,b) ((a)&(b))
#define MMXOR(a,b) ((a)+(b))
static void loeser_11(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt,*teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
				edump();
#endif
				ecnt++;
			}
			teilmsk++;
		}
#ifdef DUMP
		benutzt[teil] = (void *)0;
#endif
	}
}
static void loeser_10(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND (gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt,*teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_11(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_9(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt,*teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_10(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_8(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt,*teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_9(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_7(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk ) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt,*teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_8(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_6(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_7(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_5(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt , bitmsk ))
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_6(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_4(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt,bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_5(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_3(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt , bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_4(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_2(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt , bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_3(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_1(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	while ( MMXAND(gesamt , bitmsk) )
	{
		bitmsk >>= 1;
		bitpos --;
	}
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
		if ( benutzt[teil] )
		{
			teilmsk += cnt;
			continue;
		}
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
			if ( ! MMXAND(gesamt , *teilmsk) )
			{
#ifdef DUMP
				benutzt[teil] = teilmsk;
#endif
				loeser_2(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			}
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
static void loeser_0(ull gesamt,ull bitmsk,int bitpos)
{
	ull *teilmsk;
	int cnt;
	int teil;
	teilmsk = rec[bitpos];
	while ( *teilmsk )
	{
		teil = ((struct rec *)teilmsk)->hwert;
		cnt  = ((struct rec *)(teilmsk++))->lwert;
#ifndef DUMP
		benutzt[teil] = teilmsk;
#endif
		while ( cnt-- )
		{
#ifdef DUMP
			benutzt[teil] = teilmsk;
#endif
			loeser_1(MMXOR(gesamt,*teilmsk),bitmsk,bitpos);
			teilmsk++;
		}
		benutzt[teil] = (void *)0;
	}
}
#ifdef DUMP
/* Funktion um die Lsung mit c't Logo zu finden und auszugeben
 * das c, das t und jeweils ein ' werden gesetzt, und dann
 * ab rekursionsstufe drei gesucht
 */
int loeser_dump(int logo,int nur1)
#else
/* Aufruf fr allgemeine Suche, und Ausgabe des Ergebnis
 */
int loeser(int logo,int nur1)
#endif
{
	ecnt = 0;
	merge_teile(logo,nur1,rec);
	loeser_0(0,1LL<<59,59);
	return ecnt;
}
